package injectton.test.sessionbean;

import injection.test.enums.NumType;

import javax.ejb.EJB;
import javax.ejb.EJBs;
import javax.ejb.Local;
import javax.ejb.Remote;
import javax.ejb.Stateful;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.naming.InitialContext;
import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceContexts;

import ejb.injection.test.interfaces.NumberArabicInterface;
import ejb.injection.test.interfaces.NumberInterface;
import ejb.injection.test.interfaces.NumberInterfaceLocal;
import ejb.injection.test.interfaces.NumberInterfaceRemote;
import ejb.injection.test.interfaces.NumberRomeInterface;

@Stateful(mappedName="Number")
@EJBs({	@EJB(name = "NumberArabic", beanInterface = NumberArabicInterface.class),
		@EJB(name = "NumberRome", beanInterface = NumberRomeInterface.class) })
@Local(NumberInterfaceLocal.class)
@Remote(NumberInterfaceRemote.class)		
public class Number implements NumberInterface {
	
	private NumberInterface getMgrImpl(NumType type) {
		try{
	
		InitialContext ctx = new InitialContext();
		switch (type) {
		case ARABIC:
			NumberArabicInterface ina = (NumberArabicInterface) ctx.lookup("java:comp/env/NumberArabic");
			return ina;
		case ROME:
			NumberRomeInterface inr = (NumberRomeInterface) ctx.lookup("java:comp/env/NumberRome");
			return inr;
		default:
			return null;
		}
		}catch(Exception e) {
			e.printStackTrace();
			return null;
		}
	}
	
	public String getNumberType(NumType type){
		NumberInterface ni = getMgrImpl(type);
		if(ni != null)
			return ni.getNumberType(type);
		else
			return NumType.DEFAULT.toString();
	}

}
